'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var requestPromise = _bluebird2['default'].promisify(_request2['default'], { multiArgs: true });

var getMainSections = _bluebird2['default'].coroutine(_regeneratorRuntime.mark(function callee$0$0(articleTitle) {
  var url, response, resInfo, body, body_parsed, extractWikiJSON;
  return _regeneratorRuntime.wrap(function callee$0$0$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        extractWikiJSON = function extractWikiJSON(wikijson) {

          var obj = wikijson.query.pages[_Object$keys(wikijson.query.pages)[0]];

          if (!obj.hasOwnProperty('extract') || !obj.hasOwnProperty('title')) {
            return;
          }

          var sections = [],
              wikiextract = wikijson.query.pages[_Object$keys(wikijson.query.pages)[0]].extract,
              sectionTitlesNotIncluded = ['See also', 'References', 'Further reading', 'External links', 'Works cited', 'Cited texts'],
              cursorStart = 0,
              cursorEnd = wikiextract.indexOf('\n== ');

          if (cursorEnd === -1) {
            cursorEnd = wikiextract.length;
          }

          var level = 0,
              title = wikijson.query.pages[_Object$keys(wikijson.query.pages)[0]].title,
              abstract = { sectionLevel: level, sectionTitle: title, sectionText: wikiextract.substring(cursorStart, cursorEnd).replace(/\n+/g, '') };

          sections.push(abstract);

          var headingRE = /\n==+ (.*?) (==+)\n?/g,
              headingRE_results = headingRE.exec(wikiextract),
              text = '',
              section = {};

          while (cursorEnd !== wikiextract.length) {
            title = headingRE_results[1];
            level = headingRE_results[2].length - 1;
            cursorStart = headingRE.lastIndex;
            headingRE_results = headingRE.exec(wikiextract);
            if (headingRE_results === null) {
              cursorEnd = wikiextract.length;
            } else {
              cursorEnd = headingRE_results.index;
            }
            text = wikiextract.substring(cursorStart, cursorEnd).trim() + '\n';
            text = text.replace(/\[citation needed\]/g, '');
            text = text.replace(/\n+/g, '');
            section = { sectionLevel: level, sectionTitle: title, sectionText: text };
            if (sectionTitlesNotIncluded.indexOf(title) === -1) {
              sections.push(section);
            }
          }

          return sections;
        };

        url = 'http://en.wikipedia.org/w/api.php?redirects=true&format=json&utf8=true&action=query&titles=' + articleTitle + '&prop=extracts&explaintext=true&exsectionformat=wiki&continue=';
        context$1$0.prev = 2;
        context$1$0.next = 5;
        return requestPromise({
          url: url,
          json: true
        });

      case 5:
        response = context$1$0.sent;
        resInfo = response[0];
        body = response[1];

        if (!(resInfo.statusCode !== 200)) {
          context$1$0.next = 12;
          break;
        }

        return context$1$0.abrupt('return', '');

      case 12:
        body_parsed = extractWikiJSON(body);
        return context$1$0.abrupt('return', body_parsed);

      case 14:
        context$1$0.next = 19;
        break;

      case 16:
        context$1$0.prev = 16;
        context$1$0.t0 = context$1$0['catch'](2);

        console.log('Error: ' + context$1$0.t0);

      case 19:
      case 'end':
        return context$1$0.stop();
    }
  }, callee$0$0, this, [[2, 16]]);
}));

exports.getMainSections = getMainSections;

// Parse returned wikipedia API JSON